<template>
  <div>
    <modal v-if="modal" :title="title" @close="changeModalState">
      <category @close="changeModalState" :data="editedCategory"/>
    </modal>
    <div class="wp-title wp-12">Категории</div>
    <nav-bar v-model="search" @action="changeModalState"/>
    <masonry class="wp-12"
      :columnClass="MasonryColumnClass"
      :cols="MasonryColumns"
      :gutter="MasonryGutter">
      <card v-for="(category, index) in filteredCategories" :key="index"
        :title="category.name"
        edit @edit="changeModalState(category)">
        <div class="wp-layout">
          <div class="wp-12 wp-field">
            <div class="wp-field__title">
              Название
              <div class="wp-indicators wp-indicators--title">
                <div class="wp-indicator">N</div>
              </div>
            </div>
            <div class="wp-field__content">
              <div class="wp-field__text">
                {{ category.name }}
              </div>
              <div class="wp-indicators">
                <div class="wp-indicator"
                  :class="{
                    'wp-indicator--primary': category.allow_negative,
                    'wp-indicator--secondary': !category.allow_negative,
                  }"></div>
              </div>
            </div>
          </div>
        </div>
      </card>
    </masonry>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';

import { MasonryGutter, MasonryColumnClass, MasonryColumns } from '@/shared';

import Card from '@/components/Card.vue';
import NavBar from '@/components/NavBar.vue';

import Modal from '@/components/modal/Modal.vue';
import Category from '@/components/modal/orgadmin/categories/Category.vue';

export default {
  name: 'Categories',
  components: {
    NavBar,
    Card,
    Modal,
    Category,
  },
  data() {
    return {
      MasonryGutter,
      MasonryColumns,
      MasonryColumnClass,
      modal: false,
      titles: {
        create: 'Новая категория',
        edit: 'Редактирование категории',
      },
      editedCategory: null,
      search: '',
    };
  },
  computed: {
    ...mapState('organization', ['categories']),
    title() {
      return this.editedCategory ? this.titles.edit : this.titles.create;
    },
    filteredCategories() {
      return this.categories.filter(category => category.name.toLowerCase().indexOf(
        this.search.toLowerCase(),
      ) !== -1);
    },
  },
  methods: {
    ...mapActions('organization', [
      'getOrganizationCategories',
    ]),
    changeModalState(category = null) {
      this.editedCategory = category;
      this.modal = !this.modal;
    },
  },
  created() {
    this.getOrganizationCategories();
  },
};
</script>

<style lang="scss" scoped>
</style>
